/*****************************************************************************/
/******                                                                 ******/
/******                   Primeiro Semestre de 2001                     ******/
/******                                                                 ******/
/******      Primeiro programa de MAC-438 Programacao Concorrente       ******/
/******      Data de entrega: Quarta feira 01 de Setembo                ******/
/******      Professor: Francisco Reverbel                              ******/
/******                                                                 ******/
/******      Nomes:                                                     ******/
/******                                                                 ******/
/******        Hugo Kotsubo                       N. USP: 2957620       ******/
/******        Levi Fukumori                      N. USP: 2995112       ******/
/******                                                                 ******/
/*****************************************************************************/

#include <stdio.h>
#include <malloc.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/time.h>
#include <errno.h>
#include <unistd.h> 
#include <signal.h>
#include <stdlib.h>

#define SHM_MODE    (SHM_R | SHM_W | IPC_CREAT)  /* read/write */
#define MAX         100 // numero de itens que podem ser colocados na fila
#define TAM_BUFFER  (MAX + 1) /* Tamanho do buffer onde sao colocados os produtos */
#define SHM_SIZE    416 /* Tamanho da memoria compartilhada */

//macro para calcular o numero de itens na lista circular
// i = inicio    f = final
#define distancia(i,f)  (((i) > (f)) ? (TAM_BUFFER - (i) + (f)) : ((f) - (i)))


/******         Prototipos das funcoes usadas no programa:         ******/
double Entra_Regiao_Critica(int i, int *QualProc, int *QuerEntrar);
void Sai_Regiao_Critica(int i, int *QuerEntrar);
static void sig_usr1();
static void sig_usr2();
void produz_item(int *item);
void entra_item(int item, int IniBuffer, int *BUFFER);
int remove_item(int posicao, int *BUFFER); 
void consome_item(int item);
void erro(char *msg);
void errocode(char *msg, int code);
